/* eslint-disable no-unused-vars */
/* eslint-disable no-return-assign */
/* eslint-disable no-dupe-class-members */
/**
 * API Title
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional } from '@angular/core'
import {
  HttpClient, HttpHeaders, HttpParams,
  HttpResponse, HttpEvent, HttpParameterCodec, HttpContext
} from '@angular/common/http'
import { CustomHttpParameterCodec } from '../encoder'
import { Observable } from 'rxjs'

// @ts-ignore
import { ElementObject } from '../model/elementObject'
// @ts-ignore
import { IdentifierObject } from '../model/identifierObject'
// @ts-ignore
import { IndexObject } from '../model/indexObject'
// @ts-ignore
import { MoveObject } from '../model/moveObject'
// @ts-ignore
import { PathObject } from '../model/pathObject'
// @ts-ignore
import { WriteConfObject } from '../model/writeConfObject'

// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS } from '../variables'
import { Configuration } from '../configuration'

@Injectable({
  providedIn: 'root'
})
export class DefaultService {
    protected basePath = 'http://localhost:4222';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();
    public encoder: HttpParameterCodec;

    constructor (protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
      if (configuration) {
        this.configuration = configuration
      }
      if (typeof this.configuration.basePath !== 'string') {
        if (typeof basePath !== 'string') {
          basePath = this.basePath
        }
        this.configuration.basePath = basePath
      }
      this.encoder = this.configuration.encoder || new CustomHttpParameterCodec()
    }

    private addToHttpParams (httpParams: HttpParams, value: any, key?: string): HttpParams {
      if (typeof value === 'object' && value instanceof Date === false) {
        httpParams = this.addToHttpParamsRecursive(httpParams, value)
      } else {
        httpParams = this.addToHttpParamsRecursive(httpParams, value, key)
      }
      return httpParams
    }

    private addToHttpParamsRecursive (httpParams: HttpParams, value?: any, key?: string): HttpParams {
      if (value == null) {
        return httpParams
      }

      if (typeof value === 'object') {
        if (Array.isArray(value)) {
          (value as any[]).forEach(elem => httpParams = this.addToHttpParamsRecursive(httpParams, elem, key))
        } else if (value instanceof Date) {
          if (key != null) {
            httpParams = httpParams.append(key,
              (value as Date).toISOString().substr(0, 10))
          } else {
            throw Error('key may not be null if value is Date')
          }
        } else {
          Object.keys(value).forEach(k => httpParams = this.addToHttpParamsRecursive(
            httpParams, value[k], key != null ? `${key}.${k}` : k))
        }
      } else if (key != null) {
        httpParams = httpParams.append(key, value)
      } else {
        throw Error('key may not be null if value is not object or array')
      }
      return httpParams
    }

    /**
     * Add a new element to the selected list
     * @param listId List Index
     * @param elementObject A single element object
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public addElement(listId: number, elementObject: ElementObject, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<IndexObject>;
    public addElement(listId: number, elementObject: ElementObject, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<IndexObject>>;
    public addElement(listId: number, elementObject: ElementObject, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<IndexObject>>;
    public addElement (listId: number, elementObject: ElementObject, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling addElement.')
      }
      if (elementObject === null || elementObject === undefined) {
        throw new Error('Required parameter elementObject was null or undefined when calling addElement.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      // to determine the Content-Type header
      const consumes: string[] = [
        'application/json'
      ]
      const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes)
      if (httpContentTypeSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Content-Type', httpContentTypeSelected)
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<IndexObject>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/element/add`,
        elementObject,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Add a new list with an identifier and get the index where it was added
     * @param identifierObject A single identifier object
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public addList(identifierObject: IdentifierObject, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<IndexObject>;
    public addList(identifierObject: IdentifierObject, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<IndexObject>>;
    public addList(identifierObject: IdentifierObject, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<IndexObject>>;
    public addList (identifierObject: IdentifierObject, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      if (identifierObject === null || identifierObject === undefined) {
        throw new Error('Required parameter identifierObject was null or undefined when calling addList.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      // to determine the Content-Type header
      const consumes: string[] = [
        'application/json'
      ]
      const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes)
      if (httpContentTypeSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Content-Type', httpContentTypeSelected)
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<IndexObject>(`${this.configuration.basePath}/api/lists/add`,
        identifierObject,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Delete the selected element
     * @param listId List Index
     * @param elemId Element Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public deleteElement(listId: number, elemId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<string>;
    public deleteElement(listId: number, elemId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpResponse<string>>;
    public deleteElement(listId: number, elemId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpEvent<string>>;
    public deleteElement (listId: number, elemId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling deleteElement.')
      }
      if (elemId === null || elemId === undefined) {
        throw new Error('Required parameter elemId was null or undefined when calling deleteElement.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'text/plain'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<string>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/element/${encodeURIComponent(String(elemId))}/delete`,
        null,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Delete the selected list
     * @param listId List Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public deleteList(listId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<string>;
    public deleteList(listId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpResponse<string>>;
    public deleteList(listId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpEvent<string>>;
    public deleteList (listId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling deleteList.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'text/plain'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<string>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/delete`,
        null,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get config file as an array
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getConfig(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<number>>;
    public getConfig(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<number>>>;
    public getConfig(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<number>>>;
    public getConfig (observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<Array<number>>(`${this.configuration.basePath}/api/config/`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get the identifier of an element in a list
     * @param listId List Index
     * @param elemId Element Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getElementIdentifier(listId: number, elemId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<IdentifierObject>;
    public getElementIdentifier(listId: number, elemId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<IdentifierObject>>;
    public getElementIdentifier(listId: number, elemId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<IdentifierObject>>;
    public getElementIdentifier (listId: number, elemId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling getElementIdentifier.')
      }
      if (elemId === null || elemId === undefined) {
        throw new Error('Required parameter elemId was null or undefined when calling getElementIdentifier.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<IdentifierObject>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/element/${encodeURIComponent(String(elemId))}/identifier`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get all identifiers from elements from a list
     * @param listId List Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getElementIdentifiers(listId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<string>>;
    public getElementIdentifiers(listId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<string>>>;
    public getElementIdentifiers(listId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<string>>>;
    public getElementIdentifiers (listId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling getElementIdentifiers.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<Array<string>>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/elements/identifier`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get the path of an element in a list
     * @param listId List Index
     * @param elemId Element Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getElementPath(listId: number, elemId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<PathObject>;
    public getElementPath(listId: number, elemId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<PathObject>>;
    public getElementPath(listId: number, elemId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<PathObject>>;
    public getElementPath (listId: number, elemId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling getElementPath.')
      }
      if (elemId === null || elemId === undefined) {
        throw new Error('Required parameter elemId was null or undefined when calling getElementPath.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<PathObject>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/element/${encodeURIComponent(String(elemId))}/path`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get all paths from elements from a list
     * @param listId List Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getElementPaths(listId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<string>>;
    public getElementPaths(listId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<string>>>;
    public getElementPaths(listId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<string>>>;
    public getElementPaths (listId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling getElementPaths.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<Array<string>>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/elements/path`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get all elements from a list
     * @param listId List Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getElements(listId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<ElementObject>>;
    public getElements(listId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<ElementObject>>>;
    public getElements(listId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<ElementObject>>>;
    public getElements (listId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling getElements.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<Array<ElementObject>>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/elements`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * get the current value of footprint
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getFootPrint(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<number>;
    public getFootPrint(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<number>>;
    public getFootPrint(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<number>>;
    public getFootPrint (observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<number>(`${this.configuration.basePath}/api/config/foot-print`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get an identifier from a list
     * @param listId List Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getListIdentifier(listId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<IdentifierObject>;
    public getListIdentifier(listId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<IdentifierObject>>;
    public getListIdentifier(listId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<IdentifierObject>>;
    public getListIdentifier (listId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling getListIdentifier.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<IdentifierObject>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/identifier`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get all 256 identifiers of the media lists as an array
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getListIdentifiers(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<string>>;
    public getListIdentifiers(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<string>>>;
    public getListIdentifiers(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<string>>>;
    public getListIdentifiers (observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<Array<string>>(`${this.configuration.basePath}/api/lists/identifier`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Get all 256 Lists of the media lists as an array
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getLists(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<string>>;
    public getLists(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<string>>>;
    public getLists(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<string>>>;
    public getLists (observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<Array<string>>(`${this.configuration.basePath}/api/lists/`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * get the current value of start address
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getStartAddress(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<number>;
    public getStartAddress(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<number>>;
    public getStartAddress(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<number>>;
    public getStartAddress (observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<number>(`${this.configuration.basePath}/api/config/start-address`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * get the current value of universe
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getUniverse(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<number>;
    public getUniverse(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<number>>;
    public getUniverse(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<number>>;
    public getUniverse (observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'application/json'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.get<number>(`${this.configuration.basePath}/api/config/universe`,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Move the selected element
     * @param listId List Index
     * @param moveObject Move single element object
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public moveElement(listId: number, moveObject: MoveObject, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<string>;
    public moveElement(listId: number, moveObject: MoveObject, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpResponse<string>>;
    public moveElement(listId: number, moveObject: MoveObject, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpEvent<string>>;
    public moveElement (listId: number, moveObject: MoveObject, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling moveElement.')
      }
      if (moveObject === null || moveObject === undefined) {
        throw new Error('Required parameter moveObject was null or undefined when calling moveElement.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'text/plain'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      // to determine the Content-Type header
      const consumes: string[] = [
        'application/json'
      ]
      const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes)
      if (httpContentTypeSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Content-Type', httpContentTypeSelected)
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<string>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/element/moveElement`,
        moveObject,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Move the selected list
     * @param moveObject Move single element object
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public moveList(moveObject: MoveObject, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<string>;
    public moveList(moveObject: MoveObject, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpResponse<string>>;
    public moveList(moveObject: MoveObject, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpEvent<string>>;
    public moveList (moveObject: MoveObject, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<any> {
      if (moveObject === null || moveObject === undefined) {
        throw new Error('Required parameter moveObject was null or undefined when calling moveList.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'text/plain'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      // to determine the Content-Type header
      const consumes: string[] = [
        'application/json'
      ]
      const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes)
      if (httpContentTypeSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Content-Type', httpContentTypeSelected)
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<string>(`${this.configuration.basePath}/api/list/moveList`,
        moveObject,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Update the config file
     * @param writeConfObject Set the value in conf file
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public updateConfigFile(writeConfObject: WriteConfObject, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<string>;
    public updateConfigFile(writeConfObject: WriteConfObject, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpResponse<string>>;
    public updateConfigFile(writeConfObject: WriteConfObject, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpEvent<string>>;
    public updateConfigFile (writeConfObject: WriteConfObject, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<any> {
      if (writeConfObject === null || writeConfObject === undefined) {
        throw new Error('Required parameter writeConfObject was null or undefined when calling updateConfigFile.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'text/plain'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      // to determine the Content-Type header
      const consumes: string[] = [
        'application/json'
      ]
      const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes)
      if (httpContentTypeSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Content-Type', httpContentTypeSelected)
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<string>(`${this.configuration.basePath}/api/config/update`,
        writeConfObject,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Update the element
     * @param listId List Index
     * @param elemId Element Index
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public updateElement(listId: number, elemId: number, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<string>;
    public updateElement(listId: number, elemId: number, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpResponse<string>>;
    public updateElement(listId: number, elemId: number, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpEvent<string>>;
    public updateElement (listId: number, elemId: number, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<any> {
      if (listId === null || listId === undefined) {
        throw new Error('Required parameter listId was null or undefined when calling updateElement.')
      }
      if (elemId === null || elemId === undefined) {
        throw new Error('Required parameter elemId was null or undefined when calling updateElement.')
      }

      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'text/plain'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<string>(`${this.configuration.basePath}/api/list/${encodeURIComponent(String(listId))}/element/${encodeURIComponent(String(elemId))}/update`,
        null,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }

    /**
     * Update the list
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public updateList(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<string>;
    public updateList(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpResponse<string>>;
    public updateList(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<HttpEvent<string>>;
    public updateList (observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'text/plain', context?: HttpContext}): Observable<any> {
      let localVarHeaders = this.defaultHeaders

      let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept
      if (localVarHttpHeaderAcceptSelected === undefined) {
        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
          'text/plain'
        ]
        localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts)
      }
      if (localVarHttpHeaderAcceptSelected !== undefined) {
        localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected)
      }

      let localVarHttpContext: HttpContext | undefined = options && options.context
      if (localVarHttpContext === undefined) {
        localVarHttpContext = new HttpContext()
      }

      let responseType_: 'text' | 'json' = 'json'
      if (localVarHttpHeaderAcceptSelected && localVarHttpHeaderAcceptSelected.startsWith('text')) {
        responseType_ = 'text'
      }

      return this.httpClient.post<string>(`${this.configuration.basePath}/api/list/update`,
        null,
        {
          context: localVarHttpContext,
          responseType: <any>responseType_,
          withCredentials: this.configuration.withCredentials,
          headers: localVarHeaders,
          observe: observe,
          reportProgress: reportProgress
        }
      )
    }
}
